<?php
/**
* @version 1.1
* @package DB Admin
* @copyright (C) 2006 David Thomas
* @contact davidwhthomas@gmail.com
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/
 
/**
* DB Admin : This first version is limited to updating the database table prefix
* Disclaimer: supplied as is, no warranty, use at your own risk!
* Designed for MySQL on PHP 5. It should work fine with earlier PHP versions.
**/ 
 
/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or
    die( 'Direct Access to this location is not allowed.' );
 
/** include support library */
require_once( $mainframe->getPath( 'admin_html' ) );

 
/** handle the task */
$task = mosGetParam( $_REQUEST, 'task', '' );
 
switch ($task) {
	case "setPrefix":
	//change actual DB table prefix 
		global $mosConfig_dbprefix;
	    $current_prefix = mosGetParam($_REQUEST,cp,'');
		if(!$current_prefix){
			$current_prefix = $mosConfig_dbprefix;	//if unspecified, assign default dbprefix value
		}	
	    $new_prefix = mosGetParam($_REQUEST,np,''); //get new prefix value
	    if($current_prefix && $new_prefix){
			setTablePrefix($current_prefix, $new_prefix);
			//mosRedirect('index2.php?option=com_dbadmin',$current_prefix. " ". $new_prefix. "". mosGetParam($_REQUEST,'uc',''));
	    }
		elseif ($new_prefix == ''){ //new prefix is required
			mosRedirect('index2.php?option=com_dbadmin',"Please enter a new table prefix");
		}
    break;
    default:
        HTML_DB_ADMIN::showMainForm();
    break;
}

//helper function to replace prefix in table name once only. 
//this means if the prefix occurs elsewhere in the table name, it is only replaced once.
function replaceOnce($search, $replace, $content){

	$pos = strpos($content, $search); 
	if ($pos === false) { return $content; }
	else { return substr($content, 0, $pos) . $replace . substr($content, $pos+strlen($search)); }

}

/*sets a new database table prefix*/
function setTablePrefix($current_prefix, $new_prefix){

	global $database, $mosConfig_absolute_path;
	//let's double check that new prefix was supplied
	if(!$new_prefix){
			mosRedirect('index2.php?option=com_dbadmin',"Please enter a new table prefix");
	}
	//get full list of tables in the database
	$tables=$database->getTableList();
	//loop through and rename all the tables in the db
	//if table prefix is not found, original table name will be preserved
	foreach($tables as $table){
		$new_name = replaceOnce( $current_prefix, $new_prefix, $table );
		$sql="ALTER TABLE `".$table."` RENAME `".$new_name."`";
		$database->setQuery($sql);
		$database->query();
		$message .= "Renamed: ".$table." To: ".$new_name."<br />\n"; //verbose feedback
	}
	$msg .= "Updated table prefix: $current_prefix to $new_prefix "; //result message
	
	//update configuration file?
	$updateConfig = mosGetParam($_REQUEST,'uc','no');
	if($updateConfig == "yes"){
	
		$fname = $mosConfig_absolute_path . '/configuration.php';
		$file = file_get_contents ($fname); //load the config file into a string variable
		$search = '$mosConfig_dbprefix'." = '".$current_prefix."';";
		$replace = '$mosConfig_dbprefix'." = '".$new_prefix."';";
		$file = str_replace($search, $replace, $file); //search and replace to update the config value
		
		$enable_write 	= intval( mosGetParam( $_POST, 'enable_write', 0 ) ); //necessary to override read only protection?
		$oldperms 		= fileperms($fname); //get old permissions to restore later
		if ( $enable_write ) { //need to override read only protection
			@chmod( $fname, $oldperms | 0222);
			$msg .= " Overrode read-only protection.";
		}
		if ( $fp = fopen($fname, 'w') ) {
			fputs($fp, $file); //write the new config file
			fclose($fp);
			if ($enable_write) {
				@chmod($fname, $oldperms);
			} else {
				if (mosGetParam($_POST,'disable_write',0)){ //make config file read only
					@chmod($fname, $oldperms & 0777555);
					$msg.= " Disabled write access to config file."; //result message
					}
			} // if
			$msg .= " Updated Configuration File.";	//result message
		
		}
		else{
			$msg .= " Error: Could not open configuration file."; //result message
		}
	} //end update config file if
		

	//echo $message; //for debug	
	
	//show result
	mosRedirect('index2.php?option=com_dbadmin',$msg);

}

?>